## lamemp3enc lamemp3enc |

## Properties

gint | bitrate | Read / Write / Construct
gboolean | cbr | Read / Write / Construct
GstLameMP3EncEncodingEngineQuality | encoding-engine-quality | Read / Write / Construct
gboolean | mono | Read / Write / Construct
gfloat | quality | Read / Write / Construct
GstLameMP3EncTarget | target | Read / Write / Construct

## Types and Values

struct | GstLameMP3Enc

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstElement
                    ╰── GstAudioEncoder
                        ╰── GstLameMP3Enc

## Implemented Interfaces

GstLameMP3Enc implements GstPreset.

## Description

This element encodes raw integer audio into an MPEG-1 layer 3 (MP3) stream. Note that MP3 is not a free format, there are licensing and patent issues to take into consideration. See Ogg/Vorbis for a royalty free (and often higher quality) alternative.

### Output sample rate

If no fixed output sample rate is negotiated on the element's src pad, the element will choose an optimal sample rate to resample to internally. For example, a 16-bit 44.1 KHz mono audio stream encoded at 48 kbit will get resampled to 32 KHz. Use filter caps on the src pad to force a particular sample rate.

### Example pipelines

    1
    gst-launch-1.0 -v audiotestsrc wave=sine num-buffers=100 ! audioconvert ! lamemp3enc ! filesink location=sine.mp3

Encode a test sine signal to MP3.

    1
    gst-launch-1.0 -v autoaudiosrc ! audioconvert ! lamemp3enc target=bitrate bitrate=192 ! filesink location=alsasrc.mp3

Record from a sound card using ALSA and encode to MP3 with an average bitrate of 192kbps

    1
    gst-launch-1.0 -v filesrc location=music.wav ! decodebin ! audioconvert ! audioresample ! lamemp3enc target=quality quality=0 ! id3v2mux ! filesink location=music.mp3

Transcode from a .wav file to MP3 (the id3v2mux element is optional) with best VBR quality

    1
    gst-launch-1.0 -v cdda://5 ! audioconvert ! lamemp3enc target=bitrate cbr=true bitrate=192 ! filesink location=track5.mp3

Encode Audio CD track 5 to MP3 with a constant bitrate of 192kbps

    1
    gst-launch-1.0 -v audiotestsrc num-buffers=10 ! audio/x-raw,rate=44100,channels=1 ! lamemp3enc target=bitrate cbr=true bitrate=48 ! filesink location=test.mp3

Encode to a fixed sample rate

## Synopsis

### Element Information

plugin | lame
author | Sebastian Dröge <sebastian.droege@collabora.co.uk>
class | Codec/Encoder/Audio

### Element Pads

name | sink
direction | sink
presence | always
details | audio/x-raw, format=(string)S16LE, layout=(string)interleaved, rate=(int){ 8000, 11025, 12000, 16000, 22050, 24000, 32000, 44100, 48000 }, channels=(int)1
| audio/x-raw, format=(string)S16LE, layout=(string)interleaved, rate=(int){ 8000, 11025, 12000, 16000, 22050, 24000, 32000, 44100, 48000 }, channels=(int)2, channel-mask=(bitmask)0x0000000000000003

name | src
direction | source
presence | always
details | audio/mpeg, mpegversion=(int)1, layer=(int)3, rate=(int){ 8000, 11025, 12000, 16000, 22050, 24000, 32000, 44100, 48000 }, channels=(int)[ 1, 2 ]

## Functions

## Types and Values

### struct GstLameMP3Enc

    struct GstLameMP3Enc;

Opaque data structure.

## Property Details

### The `“bitrate”` property

      “bitrate”                  gint

Bitrate in kbit/sec (Only valid if target is bitrate, for CBR one of 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256 or 320).

Flags: Read / Write / Construct

Allowed values: [8,320]

Default value: 128

### The `“cbr”` property

      “cbr”                      gboolean

Enforce constant bitrate encoding (Only valid if target is bitrate).

Flags: Read / Write / Construct

Default value: FALSE

### The `“encoding-engine-quality”` property

      “encoding-engine-quality”  GstLameMP3EncEncodingEngineQuality

Quality/speed of the encoding engine, this does not affect the bitrate!.

Flags: Read / Write / Construct

Default value: Standard

### The `“mono”` property

      “mono”                     gboolean

Enforce mono encoding.

Flags: Read / Write / Construct

Default value: FALSE

### The `“quality”` property

      “quality”                  gfloat

VBR Quality from 0 to 10, 0 being the best (Only valid if target is quality).

Flags: Read / Write / Construct

Allowed values: [0,9.999]

Default value: 4

### The `“target”` property

      “target”                   GstLameMP3EncTarget

Optimize for quality or bitrate.

Flags: Read / Write / Construct

Default value: Quality

## See Also

lame, mad, vorbisenc